(ns hello-lisp.sicp.01-building-abstractions-with-procedures.exercises
  (:require [hello-lisp.sicp.01-building-abstractions-with-procedures.chapter
             :refer [cube]]))


;; Exercise 1.7: The `good-enough?` test used in computing square roots will not
;; be very effective for finding the square roots of very small numbers. Also,
;; in real computers, arithmetic operations are almost always performed with
;; limited precision This makes our test inadequate for very large
;; numbers. Explain these statements, with examples showing how the test fails
;; for small and large numbers. An alternative strategy for implementing
;; `good-enough?` is to watch how `guess` changes from one iteration to the next
;; and to stop when the change is a very small fraction of the guess. Design a
;; square-root procedure that uses this kind of end test. Does this work better
;; for small and large numbers?

(defn average [x y]
  (/ (+ x y) 2))

(defn sqrt
  "Returns square root of `x`. Uses the guess difference test to stop."
  [x]
  (letfn [(good-enough? [old-guess guess]
            (< (abs (- old-guess guess)) 0.001))
          (improve [guess x]
            (average guess (/ x guess)))
          (sqrt-iter [old-guess guess x]
            (if (good-enough? old-guess guess)
              guess
              (recur guess (improve guess x) x)))]
    (sqrt-iter x 1.0 x)))

(comment

  (sqrt 25)
  (sqrt 2)
  (sqrt 1234567890)
  (sqrt 0.1)

)


;; Exercise 1.8: Newton's method for cube roots is based on the fact that if `y`
;; is an approximation to the cube root of `x`, then a better approximation is
;; given by the value (x/y^2 + 2y)/3. Use this formula to implement a cube-root
;; procedure analogous to the square-root procedure.

(defn square [x]
  (* x x))

(defn crt
  "Returns cube root of `x`. Uses the guess difference test to
  stop. Internal functions close over `x` instead of taking it as a
  parameter."
  [x]
  (letfn [(good-enough? [old-guess guess]
            (< (abs (- old-guess guess)) 0.001))
          (improve [guess]
            (/ (+ (/ x (square guess)) (* 2 guess)) 3))
          (crt-iter [old-guess guess]
            (if (good-enough? old-guess guess)
              guess
              (recur guess (improve guess))))]
    (crt-iter x 1.0)))

(comment

  (crt 125)
  (crt 2)
  (crt 1234567890)
  (crt 0.1)

)


;; Exercise 1.9: Each of the following two procedures defines a method for
;; adding two positive integers in terms of the procedures `inc`, which
;; increments its argument by 1, and `dec`, which decrements its argument by 1.

(defn plus [a b]
  (if (= a 0)
    b
    (inc (plus (dec a) b))))

(defn plus* [a b]
  (if (= a 0)
    b
    (plus (dec a) (inc b))))

;; Using the substitution model, illustrate the process generated by each
;; procedure in evaluating (+ 4 5). Are these processes iterative or recursive?


;; Exercise 1.10: The following procedure computes a mathematical function
;; called Ackermann's function.

(defn A [x y]
  (cond
    (= y 0) 0
    (= x 0) (* 2 y)
    (= y 1) 2
    :else (A (- x 1) (A x (- y 1)))))

;; What are the values of the following expressions?

(comment

  (A 1 10)
  (A 2 4)
  (A 3 3)

)

;; Consider the following procedures, where `A` is the procedure defined above:

(defn f [n] (A 0 n))
(defn g [n] (A 1 n))
(defn h [n] (A 2 n))
(defn k [n] (* 5 n n ))

;; Give concise mathematical definitions for the functions computed by the
;; procedures `f`, `g`, and `h` for positive integer values of `n`. For
;; example, (k n) computes 5n^2.


;; Exercise 1.11: A function `f` is defined by the rule that
;; f(n) =
;;   n if n < 3;
;;   f(n - 1) + 2f(n - 2) + 3f(n - 3) if n >=3.

;; Write a procedure that computes `f` by means of a recursive process. Write a
;; procedure that computes `f` by means of an iterative process.


;; Exercise 1.12: The following pattern of numbers is called Pascal's triangle.
;;     1
;;    1 1
;;   1 2 1
;;  1 3 3 1
;; 1 4 6 4 1

;; The numbers at the edge of the triangle are all 1, and each number inside the
;; triangle is the sum of the two numbers above it. Write a procedure that
;; computes elements of Pascal's triangle by means of a recursive process.


;; Exercise 1.16: Design a procedure that evolves an iterative exponentiation
;; process that uses successive squaring and uses a logarithmic number of steps,
;; as its recursive analog. (Hint: Using the observation that (b^(n/2))^2
;; = (b^2)^(n/2), keep, along with the exponent `n` and the base `b`, an
;; additional state variable `a`, and define the state transformation in such a
;; way that the product ab^n is unchanged from state to state. At the beginning
;; of the process `a` taken to be 1, and the answer is given by the value of `a`
;; at the end of the process. In general, the technique of defining an
;; /invariant quantity/ that remains unchanged from state to state is a powerful
;; way to think about the design of iterative algorithms.)


;; Exercise 1.17: The exponentiation algorithms in this section are based on
;; performing exponentiation by means of repeated multiplication. In a similar
;; way, one can perform integer multiplication by means of repeated
;; addition. The following multiplication procedure (in which it is assumed that
;; our language can only add, not multiply) is analogous to the `expt`
;; procedure:

(defn mul
  "Computes the product of `a` and `b`.
  Generates a linear recursive process."
  [a b]
  (if (= b 0)
    0
    (+ a (mul a (dec b)))))

(mul 2 3)

;; This algorithm takes a number of steps that is linear in `b`. Now suppose we
;; include, together with addition, operations `double`, which doubles an
;; integer, and `halve`, which divides an (even) integer by 2. Using these,
;; design a multiplication procedure analogous to `expt**` that uses a
;; logarithmic number of steps.

(defn double [x]
  (+ x x))

(defn halve [x]
  (/ x 2))


;; Exercise 1.18: Using the results of exercises 1.16 and 1.17, devise a
;; procedure that generates an iterative process for multiplying two integers in
;; terms of adding, doubling, and halving and uses a logarithmic number of
;; steps.


;; Exercise 1.29: Simpson's Rule is a more accurate method of numerical
;; integration than the method illustrated above (used by `integral`). Using
;; Simpson's Rule, the integral of a function `f` between `a` and `b` is
;; approximated as h/3(y_0 + 4y_1 + 2y_2 + 4y_3 + 2y_4 + ... 2y_{n-2} + 4y_{n-1}
;; + y_n), where h = (b - a)/n, for some even integer `n`, and and y_k = f(a +
;; kh). (Increasing `n` increases the accuracy of the approximation.) Define a
;; procedure that takes as arguments `f`, `a`, `b`, and `n` and returns the
;; value of the integral, computed using Simpson's Rule. Use your procedure to
;; integrate `cube` between 0 and 1 (with `n` = 100 and 1000), and compare the
;; results to those of the `integral` procedure shown above.

(declare sum*)

(defn integral*
  "Computes the definite integral of function `f` from `a` to `b`
  with (even) `h` steps using Simpson's Rule. Uses iterative `sum*`."
  [f a b n]
  (let [h      (double (/ (- b a) n))
        coeffs (lazy-seq (cons 1 (cycle [4 2])))
        term   (fn [k] (* (f (+ a (* k h)))
                          (nth coeffs k)))]
    (* (/ h 3) (sum* term 0 inc n))))

(comment

  ;; exact answer is 0.25
  (integral* cube 0 1 10000)

)


;; Exercise 1.30: The `sum` procedure generates a linear recursion. The
;; procedure can be rewritten so that the sum is performed iteratively. Show how
;; to do this.,

(defn sum*
  "Computes a sum of terms, just as `sum`. Generates linear iterative
  process."
  [term a next* b]
  (letfn [(sum-iter [a result]
            (if (> a b)
              result
              (recur (next* a)
                     (+ (term a) result))))]
    (sum-iter a 0)))

(defn integral**
  "Computes the definite integral of function `f` from `a` to `b` with
  step `dx`. Uses iterative `sum*`."
  [f a b dx]
  (let [add-dx (fn [x] (+ x dx))]
    (* (sum* f (+ a (/ dx 2.0)) add-dx b) dx)))

(comment

  ;; exact answer is 0.25
  ;; no stack overflow here, `sum*` generates iterative process
  (integral** cube 0 1 0.000001)

)


;; Exercise 1.31: The `sum` procedure is only the simplest of a vast number of
;; similar abstractions that can be captured as higher-order procedures. Write
;; an analogous procedure calles `product` that returns the product of the
;; values of a function at points over a given range. Show how to define
;; `factorial` in terms of product. Also use `product` to compute approximations
;; to π using the formula pi/4 = 2/3 * 4/3 * 4/5 * 6/5 * 6/7 * 8/7... (by John
;; Wallis). Write both recursive and iterative process versions.


;; Exercise 1.32: Show that `sum` and `product` are both special cases of a
;; still more general notion called `accumulate` that combines a collection of
;; terms, using some general accumulation function

;; (accumulate combiner null-value term a next b)

;; `accumulate` takes as arguments the same term and range specifications as
;; `sum` and `product`, together with a `combiner` procedure (of two arguments)
;; that specifies how the current term is to be combined with the accumulation
;; of the preceding terms and a `null-value` that specifies what base value to
;; use when the terms run out. Write `accumulate` and show how `sum` and
;; `product` can both be defined as simple calls to `accumulate`.


;; Exercise 1.33: You can obtain an even more general version of `accumulate` by
;; introducing the notion of a /filter/ on the terms to be combined. That is,
;; combine only those terms derived from values in the range that satisfy a
;; specified condition. The resulting `filtered-accumulate` abstraction takes
;; the same arguments as `accumulate`, together with an additional predicate of
;; one argument that specifies the filter. Write `filtered-accumulate` as a
;; procedure. Show how to express the following using `filtered-accumulate`:
;; - the sum of squares of the prime numbers in the interval a to b
;; - the product of all the positive integers less than n that are relatively
;;   prime to n (all positive integers i < n such that (gcd i n) = 1).
